<!--
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
-->

<link rel="import" href="../polymer/polymer.html">
<link rel="import" href="../iron-validator-behavior/iron-validator-behavior.html">

<script>

	Polymer({
	   is: 'date-validator',

	behaviors: [
	  Polymer.IronValidatorBehavior
	],

	_buildDateObject: function(date) {
		var list = [];
		if(date instanceof Date) {
		  list = this._extractDatePartsToList(date);
		} else {
		  list = date.split('/');
		}

		o = {
			day: list[2],
			month: list[1],
			year: list[0]
		};

		return o;
	},

	_extractDatePartsToList: function(date) {
	  var year = "" + date.getFullYear();
	  var month = ("0" + (date.getMonth() + 1)).slice(-2);
	  var day = ("0" + date.getDate()).slice(-2);

	  return [year, month, day];
	}, 
	_validateYear: function(year) {
		return year.match(/^[0-9]{4}$/) !== null;
	},

	_validateMonth: function(month) {
		return month.match(/^(0?[1-9]|1[012])$/) !== null;
	},

	_validateDay: function(day, month, year) {
		return !!day && day <= this._daysInMonth(month, year);
	},

	_daysInMonth: function(month, year) { // m is 0 indexed: 0-11
		switch (month) {
			case 1 :
				return (year % 4 === 0 && year % 100) || year % 400 === 0 ? 29 : 28;
			case 8 : case 3 : case 5 : case 10 :
				return 30;
			default :
				return 31;
		}
		},

	validate: function(value) {
		if(!value) {
			return false;
		} else {
			var date = this._buildDateObject(value);

			return this._validateYear(date.year) && 
				   this._validateMonth(date.month) && 
				   this._validateDay(date.day, date.month, date.year);
		}
	}
	});

</script>